//
//
//  ursprüngliche Verrsion unverändert einzusehen bei
//  https://forum.lazarus.freepascal.org/index.php?topic=33844.0
//
//


unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Windows, Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  LCLType, Menus, ExtCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem9: TMenuItem;
    Panel1: TPanel;
    procedure FormCreate(Sender: TObject);


    procedure MenuItem4Click(Sender: TObject);
    procedure MenuItem5Click(Sender: TObject);
    procedure MenuItem7Click(Sender: TObject);
    procedure MenuItem8Click(Sender: TObject);
    procedure MenuItem9Click(Sender: TObject);
  protected
    procedure CreateParams(var Params: TCreateParams); override;
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }
var
  PrevWndProc: WNDPROC;

  dMargin: integer = 0;   //Summe 0 := keine Größenänderung möglich
  dCaption : integer = 0; //Summe 0 := keine Verschiebung möglich

function WndCallback(Ahwnd: HWND; uMsg: UINT; wParam: WParam; lParam: LParam): LRESULT; stdcall;
    const
      Margin = 2;
      Caption = 10; //add this
    var
      Rect: TRect;
      MouseX, MouseY: LongInt;


    begin
      if uMsg = WM_NCHITTEST then


      begin
        Result := Windows.DefWindowProc(Ahwnd, uMsg, wParam, lParam);
        MouseX := GET_X_LPARAM(lParam);
        MouseY := GET_Y_LPARAM(lParam);

        with Rect do
        begin
          Left := MouseX - Form1.BoundsRect.Left;
          Right := Form1.BoundsRect.Right - MouseX;
          Top := MouseY - Form1.BoundsRect.Top;
          Bottom := Form1.BoundsRect.Bottom - MouseY;


          if (Top < Margin) and (Left < (Margin + dMargin) ) then
            Result := windows.HTTOPLEFT
          else if (Top < (Margin + dMargin) ) and (Right < (Margin + dMargin) ) then
            Result := windows.HTTOPRIGHT
          else if (Bottom < (Margin + dMargin) ) and (Left < (Margin + dMargin) ) then
            Result := windows.HTBOTTOMLEFT
          else if (Bottom < (Margin + dMargin) ) and (Right < (Margin + dMargin) ) then
            Result := windows.HTBOTTOMRIGHT
          else if (Top < (Margin + dMargin) ) then
            Result := windows.HTTOP
          else if (Top > (Margin + dMargin) ) and (Top < (Caption + dCaption) ) then //add this line
            Result := windows.HTCAPTION
          else if (Left < (Margin + dMargin) ) then
            Result := windows.HTLEFT
          else if (Bottom < (Margin + dMargin) ) then
            Result := windows.HTBOTTOM
          else if (Right < (Margin + dMargin) ) then
            Result := windows.HTRIGHT;

        end;


        Exit;
      end;
      Result := CallWindowProc(PrevWndProc,Ahwnd, uMsg, WParam, LParam);


    end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  PrevWndProc := Windows.WNDPROC(SetWindowLongPtr(Self.Handle, GWL_WNDPROC, PtrInt(@WndCallback)));

  MenuItem5.Click;
  MenuItem8.Click;
  Panel1.Caption:='Zentrum';
  Label3.Caption:='Veschiebung AN -> gedrückte LinkeMaustaste mit Mauszeiger in Ebene vom Hauptmenu';
  Label4.Caption:='Größenänderung AN -> mit gedrückter LinkeMausTaste bei Mauszeiger am Randbereich';

end;



procedure TForm1.MenuItem4Click(Sender: TObject);
begin
  Form1.Close;
end;

procedure TForm1.MenuItem5Click(Sender: TObject);
begin
  MenuItem5.Checked:=true;
  MenuItem7.Checked:=false;

  dCaption := 0; //Summe 10 := Verschiebung möglich
  Label2.Caption := 'dCaption = ' + inttostr(dCaption);

end;

procedure TForm1.MenuItem7Click(Sender: TObject);
begin
  MenuItem5.Checked:=false;
  MenuItem7.Checked:=true;

  dCaption := -99; //Summe <0 := keine Verschiebung möglich
  Label2.Caption := 'dCaption = ' + inttostr(dCaption);

end;

procedure TForm1.MenuItem8Click(Sender: TObject);
begin
  MenuItem8.Checked:=true;
  MenuItem9.Checked:=false;

  Form1.BorderWidth:=1;
  dMargin := 0; // Summe 2:= Größenänderung möglich
  Label1.Caption := 'dMargin = ' + inttostr(dMargin);

end;

procedure TForm1.MenuItem9Click(Sender: TObject);
begin
  MenuItem8.Checked:=false;
  MenuItem9.Checked:=true;

  Form1.BorderWidth:=1;
  dMargin := -99; //Summe <0:= keine Größenänderung möglich // warum der offset nötig ist ist mir nicht ersichtlich
  Label1.Caption := 'dMargin = ' + inttostr(dMargin);
end;

procedure TForm1.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  Self.BorderStyle := bsNone;


end;

end.

